<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Dimensions (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Dimensions (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    $command = "SELECT ATRT_ID as DimensionID, ATRT_NAME as DimensionName, RLN_ID as BaseRelationID";
    $command .= " FROM ATTRIBUTE_TYPES, RELATION_TYPES";
    $command .= " WHERE ATRT_ID_L=ATRT_ID_R AND ATRT_ID_L=ATRT_ID AND RLN_NAME=RLV_NAME AND RLN_NAME='base'";
    
    //debug_trace($command);
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      $relid = ODBC_Result($rs, 3);
      echo "<td><a href=\"detail.php?oid=$oid&relid=$relid\">$oid</a></td>";
      for($col=2; $col<=$nCols; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<p><em>Hint:</em> A new dimension can be added defining a new <EM>hierarchical attribute</EM>.
Use <A href="../attribute_types/browse.php">Attribute types</A> to 
do this work.
<?  
  } while(false); 
?>
</BODY>
</HTML>