<?
  
  class ObjectType {
    var $conn;  //connection handle
    
    var $oid;
    var $name;
    var $category;
    
    function ObjectType($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(TYPE_ID) as _COUNT, Max(TYPE_ID) as _MAX FROM OBJ_TYPES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->name)) {
        write_error("Name must be non-empty string!");
        return false;
      }
      return true;
    }
    
    function create() {
      $command = "INSERT INTO OBJ_TYPES (TYPE_ID, TYPE_NAME, CATEGORY) VALUES (";
      $command .= $this->oid;
      $command .= ", '" . $this->name;
      $command .= "', " . $this->category;
      $command .= ")";
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
    }
    
    function modify() {
      $command = "UPDATE OBJ_TYPES SET TYPE_NAME='";
      $command .= $this->name;
      $command .= "', CATEGORY=".$this->category;
      $command .= " WHERE TYPE_ID=" . $this->oid;

      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
    }
    
    function load($oid) {
      $command = "SELECT TYPE_ID, TYPE_NAME, CATEGORY FROM OBJ_TYPES WHERE TYPE_ID=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->name = ODBC_Result($rs, 2);
      $this->category = ODBC_Result($rs, 3);
      return true;
    }
    
    function delete() {
      /* delete object type slave relationships */
      $command = "DELETE FROM OBJ_TYPE_RELS WHERE TYPE_ID_R=".$this->oid;
      ODBC_Exec($this->conn, $command);      
    
      /* delete object type attributes */
      $command = "DELETE FROM OBJ_TYPE_ATTRIBUTES WHERE TYPE_ID=".$this->oid;
      ODBC_Exec($this->conn, $command);      
      
      /* delete object type */
      $command = "DELETE FROM OBJ_TYPES WHERE TYPE_ID=".$this->oid;
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);      
    }
  }
?>