<HTML>
<head>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Object types (detail)</TITLE>
</head>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
<TD>/</TD>
<TD><A href="type_browse.php">Object types</a></TD>
</TR></TABLE>
<HR>
<H1>Object types (detail)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  require "../shared.php";

  require "../rel_types/rsp_cache.php";    
  require "./object.php";

  function addRelatedObj($conn, $relid, $oid_l, $oid_r) {
    /* invalidate cache */
    $rc = new RspCache($conn, $relid);
    $rc->invalidate();
  
    $command = "INSERT INTO RELATIONSHIPS (REL_ID, OID_L, OID_R) VALUES (".$relid;
    $command .= ", ".$oid_l;
    $command .= ", ".$oid_r;
    $command .= ")";
    
    @ODBC_Exec($conn, $command);
  }
  
   function delRelatedObj($conn, $relid, $oid_l, $oid_r) {
    /* invalidate cache */
    $rc = new RspCache($conn, $relid);
    $rc->invalidate();

     $command = "DELETE FROM RELATIONSHIPS WHERE REL_ID=".$relid;
     $command .= " AND OID_L=".$oid_l;
     $command .= " AND OID_R=".$oid_r;
     
     ODBC_Exec($conn, $command);
   }

?>
<?
  $item = null;
  $showForm = true; //show form by default
  
  /* write object type */
  if($make_persitent == "true"):
  //proceed write code
    $item = new Object($conn);
    $item->oid = $oid;
    $item->otid = $otid;
    $item->name = $name;
    $item->descr = $descr;

    if($action == "Apply") {
      if($item->validate()) {
        if($newRecord == "true")
          $item->create();
        else
          $item->modify();
        /* attributes section */
        $item->writeOAtrs($oatrs);
        $item->writeHAtrs($hatrs);
        /* relationships section */
        
        /* hide form */
        //$showForm = false;
      }
    }
    else if ($action == "Delete") {
      $item->delete();
      $showForm = false;
    }
  endif;

  switch($ext_code) {
    case "rsp_add":
      addRelatedObj($conn, $relid, $oid_l, $oid_r);
      break;
    case "rsp_del":
      delRelatedObj($conn, $relid, $oid_l, $oid_r);
      break;
  }
  
  $allOK = true;
  if($item == null):
    //show add/modify form
    $item = new Object($conn);
    if(!$oid) {
      //add action
      $item->oid = $item->newOid();
      $item->otid = $otid;
      $item->name = "";
      $item->descr = "";
    }
    else {
      //modify operation
      $result = $item->load($oid);
      if($result == false) {
        write_error("Invalid ID!");
        $allOK = false;
      }
    }
  endif;
    
  if($allOK && $showForm==true):
?>
    <form action="detail.php" method="post">
      <?if(!$oid || $newRecord): //new record?>
        <input  type="hidden" name="newRecord" value="true">
      <?endif;?>
      <input type="hidden" name="make_persitent" value="true">
      <input type="hidden" name="otid" value="<?echo $item->otid;?>">
      <table width="400">
        <?form_text_ro("ID:", "oid", $item->oid);?>
        <?form_text_ro("TypeName:", "otname", $item->getTypeName());?>
        <?form_text_item("Name:", "name", $item->name, 50, 1024, true);?>
        <?form_text_item("Description:", "descr", $item->descr, 50, 2048, false);?>
      </table>
    
      <H2>Attributes</H2>
<?
      $oatrs = $item->loadOAtrs();
      echo "<table>\n";
      for($i=0; $i<Count($oatrs); $i++) {
        $atr = $oatrs[$i];
        form_text_item($atr->atname, "oatrs[".$atr->atid."]", $atr->atvalue, 30, 1024, $atr->atflag);
      }

      
      /* hierarchical attributes */
      $hatrs = $item->loadHAtrs();

      for($i=0; $i<Count($hatrs); $i++) {
        $atr = $hatrs[$i];
        $hids = Array();
        $hvals = Array();
        loadAtrtVals($conn, $atr->atid, $hids, $hvals);
?>
        <tr>
          <?if($atr->atflag == true):?>
          <td><strong><?echo $atr->atname;?></strong></td>
          <?else:?>
          <td><?echo $atr->atname;?></td>
          <?endif;?>
          <td>
            <SELECT  NAME="hatrs[<? echo $atr->atid?>]" ALIGN="left" SIZE="1">
              <?if($atr->atflag != true) {
                  echo "<OPTION value=\"-1\">&lt;none&gt;";
                }
                for($j=0; $j<Count($hids); $j++) {
                  echo "<OPTION  VALUE=\"".$hids[$j]."\"";
                  echo ($atr->atvalue == $hids[$j]) ? "SELECTED" : "";
                  echo ">".$hvals[$j];
                }?>  
            </SELECT>
          </td>
        </tr>
<?        
      }
      echo "</table>\n";
?>
      <table width="400">
        <tr><td align="right">
           <input type="Submit" name="action" value="Apply">&nbsp;&nbsp;
          <input type="Reset" value="Reset">&nbsp;&nbsp;
           <input type="Submit" name="action" value="Delete" onClick="return confirm('Really delete?')">
        </td></tr>
      </table>
    </form>
<?    mandatory_notify();?>

    <H2>Relationships</H2>
<?      
      $command = "SELECT OTR.REL_ID, RT.REL_NAME, RT.REV_NAME, RT.REL_CARDINALITY, OTR.TYPE_ID_L, OT1.TYPE_NAME, OTR.TYPE_ID_R, OT2.TYPE_NAME, OTR.REL_MANDATORY";
      $command .= " FROM OBJ_TYPE_RELS OTR, REL_TYPES RT, OBJ_TYPES OT1, OBJ_TYPES OT2";
      $command .= " WHERE OTR.REL_ID = RT.REL_ID AND OTR.TYPE_ID_L = OT1.TYPE_ID AND OTR.TYPE_ID_R = OT2.TYPE_ID";
      $command .= " AND (OTR.TYPE_ID_L = ".$item->otid." OR OTR.TYPE_ID_R=".$item->otid.")";
      $command .= " ORDER BY RT.REL_NAME, RT.REV_NAME, OT1.TYPE_NAME, OT2.TYPE_NAME";

      $rs = ODBC_Exec($conn, $command);
      def_table_begin();
      echo "<tr><th>Name</th><th>RevName</th><th>Card.</th><th>Master</th><th>Slave</th><th>Mandatory</th></tr>\n";
      while(ODBC_Fetch_Row($rs)) {
        $relid = ODBC_Result($rs, 1);
        $nameA = ODBC_Result($rs, 2);
        $revNameA = ODBC_Result($rs, 3);
        $card = ODBC_Result($rs, 4);
        $otid_l = ODBC_Result($rs, 5);
        $otname_lA = ODBC_Result($rs, 6);
        $otid_r = ODBC_Result($rs, 7);
        $otname_rA = ODBC_Result($rs, 8);
        $rflag = (ODBC_Result($rs, 9) == "T") ? "YES" : "NO";

        $master = ($item->otid == $otid_l) ? true : false;
        $cnt;
        if($otid_l == $otid_r)
          $cnt = 2;
        else
          $cnt = 1;
        
        while($cnt) {
          if($master) {
            $name = "<B>".$nameA."</B>";
            $revName = $revNameA;
            $otname_l = "<B>&lt;this&gt;</B>";
            $otname_r = $otname_rA;
          }
          else {
            $name = $nameA;
            $revName = "<B>".$revNameA."</B>";;
            $otname_l = $otname_lA;
            $otname_r = "<B>&lt;this&gt;</B>";
          }
          echo "<tr>";
          echo "<td>$name</td><td>$revName</td><td align=\"center\">$card</td>";
          echo "<td>$otname_l</td><td>$otname_r</td>";
          echo "<td align=\"center\">$rflag</td>";
          echo "</tr>\n";
        
          /* relationships of given type */
          $ids = Array();
          $names = Array();
          $otid_second;
          if($master)
            $otid_second = $otid_r;
          else
            $otid_second = $otid_l;
          loadRelatedObjs($conn, $relid, $master, $item->oid, $otid_second, $ids, $names);

          echo "<tr><td colspan=\"6\">\n";
          echo "<table width=\"100%\">\n";
          for($i=0; $i<Count($ids); $i++):
            echo "<tr>";
            echo "<td><a href=\"detail.php?otid=$otid_second&oid=$ids[$i]\">$names[$i]</a></td>";
            $oid_l;
            $oid_r;
            if($master) {
              $oid_l = $item->oid;
              $oid_r = $ids[$i];
            } else { //slave
              $oid_l = $ids[$i];
              $oid_r = $item->oid;
            }
            echo "<td align=\"right\"><a href=\"detail.php?ext_code=rsp_del&relid=$relid&oid_l=$oid_l&oid_r=$oid_r&oid=$item->oid&otid=$item->otid\">delete</a></td>";
            echo "</tr>\n";
          endfor;
           echo "</table>\n";
  
          $ids = Array();
          $names = Array();
          loadObjects($conn, $otid_second, $ids, $names);
?>        
          <form action="detail.php" method="post">
            <input type="hidden" name="<? echo ($master)?"oid_l":"oid_r";?>" value="<? echo $item->oid; ?>">
            <input type="hidden" name="ext_code" value="rsp_add">
            <input type="hidden" name="relid" value="<?echo $relid;?>">
            <input type="hidden" name="oid" value="<?echo $item->oid;?>">
            <input type="hidden" name="otid" value="<?echo $item->otid;?>">
            <table width="100%"><tr>
              <td>
                <SELECT  NAME="<? echo (!$master)?"oid_l":"oid_r";?>" ALIGN="left" SIZE="1">
                  <?for($i=0; $i<Count($ids); $i++) {
                     echo "<OPTION  VALUE=\"".$ids[$i]."\"";
                    echo ">".$names[$i];
                  }?>  
                </SELECT>
              </td>
              <td align="right">
                 <INPUT TYPE="Submit" NAME="add_relationship" VALUE="Add item">
              </td>
            </tr></table>
          </form>
<?
          $cnt--;
          $master = !$master;
        }
        echo "</td></tr>\n";
      }
      def_table_end();
  endif;
?>
    <hr>
    <table>
      <tr>
        <td>
          <form action="browse.php" method="get">
            <input type="Submit" value="Browse">
            <input type="hidden" name="otid" value="<?echo $otid;?>">
          </form>
        </td>
        <td>
          <form action="detail.php" method="get">
            <input type="Submit" value="Add">
            <input type="hidden" name="otid" value="<?echo $otid;?>">
           </form>
        </td>
      </tr>
    </table>


</BODY>
</HTML>