<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Object types (by category listing)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
</TR></TABLE>
<HR>
<H1>Object types (by category listing)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  
  require "../shared.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    
    if($mode == "ro") {
      $appendix = "&mode=ro";
      echo "<P align=\"center\">Read-only mode</P>";
    }
    
    $cids = Array();
    $cnames = Array();
    loadCategories($conn, $cids, $cnames);
    for($i=0; $i<Count($cids); $i++):
      echo "<H2>$cnames[$i]</H2>\n";
      
      $command = "SELECT OBJ_TYPES.TYPE_ID as ID, OBJ_TYPES.TYPE_NAME as Name";
      $command .= " FROM OBJ_TYPES";
      $command .= " WHERE OBJ_TYPES.CATEGORY = ".$cids[$i];
      $command .= " ORDER BY OBJ_TYPES.TYPE_NAME";
      
      $rs = ODBC_Exec($conn, $command);
      
      echo "<blockquote>\n";
      while(ODBC_Fetch_Row($rs)){
        $otid = ODBC_Result($rs, 1);
        $otname = ODBC_Result($rs, 2);
        echo "<a href=\"browse.php?otid=$otid$appendix\">$otname</a><BR>\n";
      }    
      echo "</blockquote>\n";
    endfor;
    
    ODBC_Close($conn);
?>
<hr>
<?  
  } while(false); 
?>
</BODY>
</HTML>