<HTML>
<head>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Relationship types (detail)</TITLE>
</head>
<BODY>
<TABLE cellspacing="2">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Relationship types (detail)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  
  require "./rel_type.php";
?>
<?
  $showInputForm = true; //show form by default
  $item = null;
  
  if($make_persitent == "true"):
    $showInputForm = false;
  //proceed write code
    $item = new RelType($conn);
    $item->oid = $oid;
    $item->name = $name;
    $item->revName = $revName;
    $item->cardinality = $cardinality;
    $item->r = $r;
    $item->s = $s;
    $item->t = $t;

    if($Action == "Apply") {
      if($item->validate()) {
        if($newRecord == "true")
          $item->create();
        else
          $item->modify();
      }
      else {
        $showInputForm = true;  //force user to correct values
      }
    }
    else if ($Action == "Delete") {
      $item->delete();
    }
  endif;
    
  if(!$showInputForm):
?>
    <table>
      <tr>
        <td>
          <form action="browse.php" method="get">
            <input type="Submit" value="Browse">
          </form>
        </td>
        <td>
          <form action="detail.php" method="get">
            <input type="Submit" value="Add">
           </form>
        </td>
      </tr>
    </table>
<?  
  else:
    $allOK = true;
    if($item == null):
      //show add/modify form
      $item = new RelType($conn);
      if(!$oid) {
        //add action
        $item->oid = $item->newOid();
        $item->name = "";
        $item->revName = "";
        $item->cardinality = "1N";
        $item->r = "U";
        $item->s = "U";
        $item->t = "U";
      }
      else {
        //modify operation
        $result = $item->load($oid);
        if($result == false) {
          write_error("Invalid ID!");
          $allOK = false;
        }
      }
    endif;
    
    if($allOK):
?>
      <form action="detail.php" method="post">
      <?if(!$oid || $newRecord): //new record?>
        <input  type="hidden" name="newRecord" value="true">
      <?endif;?>
        <input  type="hidden" name="make_persitent" value="true">
        <table>
          <?form_text_ro("ID:", "oid", $item->oid);?>
          <?form_text_item("Name:", "name", $item->name, 30, 256, true);?>
          <?form_text_item("RevName:", "revName", $item->revName, 30, 256, true);?>
          <?if(!$oid || $newRecord): //new record?>
            <tr>
              <td><b>Cardinality:</b></td>
              <td>
              <SELECT  NAME="cardinality" ALIGN="left" SIZE="1" WIDTH="30" HEIGHT="3">
                <OPTION  VALUE="11" <?echo $item->cardinality == "11" ? "SELECTED" : ""?>>11
                <OPTION  VALUE="1N" <?echo $item->cardinality == "1N" ? "SELECTED" : ""?>>1N
                <OPTION  VALUE="MN" <?echo $item->cardinality == "MN" ? "SELECTED" : ""?>>MN
              </SELECT>
              </td>
              <td>&nbsp;</td>
            </tr>
            <tr>
              <td><b>Reflexive:</b></td>
              <td>
              <SELECT  NAME="r" ALIGN="left" SIZE="1" WIDTH="30" HEIGHT="3">
                <OPTION  VALUE="U" <?echo $item->r == "U" ? "SELECTED" : ""?>>NONE
              <!--  <OPTION  VALUE="Y" <?echo $item->r == "Y" ? "SELECTED" : ""?>>YES -->
                <OPTION  VALUE="N" <?echo $item->r == "N" ? "SELECTED" : ""?>>ANTI
              </SELECT>
              </td>
              <td>Note: <em>Reflexive relationships has been disabled.</em></td>
            </tr>
            <tr>
              <td><b>Symmetric:</b></td>
              <td>
              <SELECT  NAME="s" ALIGN="left" SIZE="1" WIDTH="30" HEIGHT="3">
                <OPTION  VALUE="U" <?echo $item->s == "U" ? "SELECTED" : ""?>>NONE
                <OPTION  VALUE="Y" <?echo $item->s == "Y" ? "SELECTED" : ""?>>YES
                <OPTION  VALUE="N" <?echo $item->s == "N" ? "SELECTED" : ""?>>ANTI
              </SELECT>
              </td>
              <td>&nbsp;</td>
            </tr>
            <tr>
              <td><b>Transitive:</b></td>
              <td>
              <SELECT  NAME="t" ALIGN="left" SIZE="1" WIDTH="30" HEIGHT="3">
                <OPTION  VALUE="U" <?echo $item->t == "U" ? "SELECTED" : ""?>>NONE
                <OPTION  VALUE="Y" <?echo $item->t == "Y" ? "SELECTED" : ""?>>YES
                <OPTION  VALUE="N" <?echo $item->t == "N" ? "SELECTED" : ""?>>ANTI
              </SELECT>
              </td>
              <td>&nbsp;</td>
            </tr>
          <?endif;?>
          <tr><td COLSPAN="2" align="right">
             <input type="Submit" name="Action" value="Apply">&nbsp;&nbsp;
            <input type="Reset" value="Reset">&nbsp;&nbsp;
             <input type="Submit" name="Action" value="Delete" onClick="return confirm('Really delete?')">
          </td></tr>
        </table>
      </form>
      
      <?mandatory_notify();?>
      <hr>
      <form action="browse.php" method="get">
        <input type="Submit" value="Browse">
      </form>
<?      
    endif;
  endif;
?>

</BODY>
</HTML>