<?
  class TypeCategory {
    var $conn;  //connection handle
    
    var $oid;    //object ID (CATEGORY)
    var $description;  //DISPLAY_NAME
    
    function TypeCategory($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(CATEGORY) as _COUNT, Max(CATEGORY) as _MAX FROM TYPE_CATEGORIES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->description)) {
        write_error("Description must be non-empty string!");
        return false;
      }
      return true;
    }
    
    function create() {
      $command = "INSERT INTO TYPE_CATEGORIES (CATEGORY, DISPLAY_NAME) VALUES (";
      $command .= $this->oid;
      $command .= ", '" . $this->description;
      $command .= "')";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function modify() {
      $command = "UPDATE TYPE_CATEGORIES SET DISPLAY_NAME='";
      $command .= $this->description;
      $command .= "' WHERE CATEGORY=" . $this->oid;

      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function load($oid) {
      $command = "SELECT CATEGORY, DISPLAY_NAME FROM TYPE_CATEGORIES WHERE CATEGORY=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->description = ODBC_Result($rs, 2);
      return true;
    }
    
    function delete() {
      $command = "DELETE FROM TYPE_CATEGORIES WHERE CATEGORY=".$this->oid;
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
  }
?>