<?
  function write_error($err_msg) {
    echo "<p><b>ERROR:&nbsp;</b>$err_msg</p>\n";
  }
  
  function write_info($msg) {
    echo "<p><b>INFO:&nbsp;</b>$msg</p>\n";
  }

  function debug_trace($msg) {
    echo "<p><b>TRACE:&nbsp;</b><kbd>$msg</kbd></p>\n";
  }
  
  function def_table_begin() {
    //echo "<blockquote>\n";
    echo "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\">\n";
  }
  
  function def_table_end() {
    echo "</table>\n";
    //echo "</blockquote>\n";
  }
  
  /* form text input line */
  function form_text_item($label, $name, $value, $len, $maxLen, $mandatory=false, $helpstring="&nbsp;") {
    echo "<tr><td>";
    if($mandatory)
      echo "<b>$label</b>";
    else
      echo "$label";
    echo "</td><td><input type=\"text\" name=\"$name\" value=\"$value\" size=\"$len\" maxlength=\"$maxLen\"></td><td>$helpstring</td></tr>\n";
  } 
  
  /* form text read-only item */
  function form_text_ro($label, $name, $value, $helpstring="&nbsp;") {
    echo "<tr><td>$label</td><td>$value";
    echo "<input type=\"Hidden\" name=\"$name\" value=\"$value\">";
    echo "</td><td>$helpstring</td></tr>\n";
  }
  
  function mandatory_notify() {
    echo "<p>Note: <em>Mandatory fields are formatted as </em><b>bold</b>.</p>\n";
  }
  
  /* ODBC (flat) transaction support */
  function begin_transaction($conn) {
    return ODBC_AutoCommit($conn, false);
  }
  
  function end_transaction($conn, $commit) {
    if($commit == true) {
      if(!ODBC_Commit($conn)) return false;
    }
    else {
      ODBC_RollBack($conn);
    }
    return ODBC_AutoCommit($conn, true);
  }
?>