<?
  require "../dimensions/dimension.php";
  
  class AttributeType {
    var $conn;  //connection handle
    
    var $oid;
    var $name;
    var $class;
    
    function AttributeType($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(ATRT_ID) as _COUNT, Max(ATRT_ID) as _MAX FROM ATTRIBUTE_TYPES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->name)) {
        write_error("Name must be non-empty string!");
        return false;
      }
      return true;
    }
    
    function create() {
      $command = "INSERT INTO ATTRIBUTE_TYPES (ATRT_ID, ATRT_NAME, ATRT_CLASS) VALUES (";
      $command .= $this->oid;
      $command .= ", '" . $this->name;
      $command .= "', '" . $this->class;
      $command .= "')";
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
      
      /* create a new dimension */
      if($this->class == "H") {
        $dm = new Dimension($this->conn, $this->oid);
        $dm->create();
      }
    }
    
    function modify() {
      $command = "UPDATE ATTRIBUTE_TYPES SET ATRT_NAME='";
      $command .= $this->name;
      $command .= "' WHERE ATRT_ID=" . $this->oid;

      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
    }
    
    function load($oid) {
      $command = "SELECT ATRT_ID, ATRT_NAME, ATRT_CLASS FROM ATTRIBUTE_TYPES WHERE ATRT_ID=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->name = ODBC_Result($rs, 2);
      $this->class = ODBC_Result($rs, 3);
      return true;
    }
    
    function delete() {
      $this->load($this->oid);
      if($this->class == "H") {
        $dm = new Dimension($this->conn, $this->oid);
        $dm->delete();
      }
      
      $command = "DELETE FROM ATTRIBUTE_TYPES WHERE ATRT_ID=".$this->oid;
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);      
    }
  }
?>