<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Attribute types (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Attribute types (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    $rs = ODBC_Exec($conn, "SELECT ATRT_ID as ID, ATRT_NAME as Name, ATRT_CLASS as Class FROM ATTRIBUTE_TYPES ORDER BY ATRT_NAME");
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      echo "<td><a href=\"detail.php?oid=$oid\">$oid</a></td>";
      for($col=2; $col<=$nCols-1; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      //last column (ATRT_CLASS)
      $class = ODBC_Result($rs, $nCols);
      if($class == 'H') {
        $class = "Hierarchical";
      }
      else if($class == 'O') {
        $class = "Ordinal";
      }
      echo "<td>".$class."</td>";
      echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<form  action="detail.php" method="get">
<input  type="Submit" name="Add" value="Add">
</form>
<br>
<p><em>Hint:</em> Use <A href="../dimensions/browse.php">Dimensions</A> to edit values of hierarchical attributes
and to define <em>base</em> relations of these dimensions.
<?  
  } while(false); 
?>
</BODY>
</HTML>