<HTML>
<head>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Dimensions (detail)</TITLE>
</head>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Dimensions (detail)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  
  require "./dimension.php";
  
  function Indent($level) {
    $indentStep = "  ";
    $result = "";
    while($level-- > 0) {
      $result .= $indentStep;
    }
    return $result;
  }
?>
<?
  if(IsSet($relid))
    $dm = new Dimension($conn, $oid, $relid);
  else
    $dm = new Dimension($conn, $oid);
//  debug_trace("DimensionID: ".$dm->oid);
//  debug_trace("BaseRelationID: ".$dm->relid);
  $dm->loadDimension();
/*  
  $nds = $dm->nodes;
  Reset($nds);
  while(Current($nds)) {
    $nd = Current($nds);
    echo "Key: ".Key($nds)." ";
    echo "NodeId: ".$nd->nodeId." ";
    echo "NodeName: ".$nd->nodeName." (";
    Reset($nd->subNodes);
    while(Current($nd->subNodes)) {
      echo Current($nd->subNodes).", ";
      Next($nd->subNodes);
    }
    echo ")<br>\n";
    Next($nds);
  }
*/
?>
<p><b>Dimension:&nbsp;</b><? echo $dm->name; ?>&nbsp;(<a href="#etv">expanded tree view</a>)
<pre><kbd><?
  $dm->resetWalk();
  $level;
  $nodeid;
  $nodename;
  while($dm->getNextElement($level, $nodeid, $nodename)) {
    echo Indent($level);
    if($nodename == "root") {
      echo "$nodename\n";
    } else {
      echo "<a href=\"value_edit.php?oid=$nodeid&relid=$dm->relid&atrtid=$dm->oid\">$nodename</a>\n";
    }
  }
?>
</kbd></pre>
<hr>
    <table>
      <tr>
        <td>
          <form action="browse.php" method="get">
            <input type="Submit" value="Browse">
          </form>
        </td>
        <td>
          <form action="value_edit.php" method="get">
            <input  type="hidden" name="atrtid" value="<? echo $dm->oid; ?>">
            <input  type="hidden" name="relid" value="<? echo $dm->relid; ?>">
            <input type="Submit" value="Add value">
           </form>
        </td>
      </tr>
    </table>
  
    <p><strong>Notes:</strong>  
     <DL>
    <DT><a name="etv">expanded tree view</a>
    <DD>This view expands the dimmension lattice into a tree.
    <DD>Nodes having multiple parents occur more than once in the above tree.
</BODY>
</HTML>