<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Object types (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Object types (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    $command = "SELECT OBJ_TYPES.TYPE_ID as ID, TYPE_CATEGORIES.DISPLAY_NAME as Category, OBJ_TYPES.TYPE_NAME as Name";
    $command .= " FROM OBJ_TYPES, TYPE_CATEGORIES";
    $command .= " WHERE OBJ_TYPES.CATEGORY =  TYPE_CATEGORIES.CATEGORY";
    $command .= " ORDER BY TYPE_CATEGORIES.DISPLAY_NAME, OBJ_TYPES.TYPE_NAME";
    
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      echo "<td><a href=\"detail.php?oid=$oid\">$oid</a></td>";
      for($col=2; $col<=$nCols; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<form  action="detail.php" method="get">
<input  type="Submit" value="Add">
</form>
<?  
  } while(false); 
?>
</BODY>
</HTML>