<HTML>
<head>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Object types (detail)</TITLE>
</head>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Object types (detail)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  require "../shared.php";
    
  require "./obj_type.php";
  
  function addAttribute($conn, $type_id, $atid, $atflag) {
    $command = "INSERT INTO OBJ_TYPE_ATTRIBUTES (TYPE_ID, ATRT_ID, OTA_MANDATORY)";
    $command .= " VALUES (".$type_id;
    $command .= ", ".$atid;
    $command .= ", '".$atflag;
    $command .= "')";
    
    @ODBC_Exec($conn, $command);
  }
  
  function delAttribute($conn, $type_id, $atid) {
    $command = "DELETE FROM OBJ_TYPE_ATTRIBUTES WHERE TYPE_ID=".$type_id;
    $command .= " AND ATRT_ID=".$atid;
    
    ODBC_Exec($conn, $command);
  }
  
  function addRelationship($conn, $relid, $ot_l, $ot_r, $rflag) {
    $command = "INSERT INTO OBJ_TYPE_RELS (REL_ID, REL_MANDATORY, TYPE_ID_L, TYPE_ID_R)";
    $command .= " VALUES (".$relid;
    $command .= ", '".$rflag;
    $command .= "', ".$ot_l;
    $command .= ", ".$ot_r;
    $command .= ")";

    @ODBC_Exec($conn, $command);
  }
  
  function delRelationship($conn, $relid, $ot_l, $ot_r) {
    $command = "DELETE FROM OBJ_TYPE_RELS WHERE REL_ID=".$relid;
    $command .= " AND TYPE_ID_L=".$ot_l;
    $command .= " AND TYPE_ID_R=".$ot_r;
    
    ODBC_Exec($conn, $command);  
  }
?>
<?
  $exists = false;  //record does not exist, do not show attr. & relshp.
  $item = null;
  $showForm = true; //show form by default
  
  /* write object type */
  if($make_persitent == "true"):
  //proceed write code
    $item = new ObjectType($conn);
    $item->oid = $oid;
    $item->name = $name;
    $item->category = $category;

    if($action == "Apply") {
      if($item->validate()) {
        if($newRecord == "true")
          $item->create();
        else
          $item->modify();
        $exists = true; //OK, objects exists now, you can show additional form
      }
    }
    else if ($action == "Delete") {
      $item->delete();
      $showForm = false;
    }
  endif;
  
  //additional codes (attributes, relationships)
  switch($ext_code) {
    case "att_add":
      $atflag = ($atflag == "T") ? "T" : "F";
      addAttribute($conn, $oid, $atid, $atflag);
      break;
    case "att_del":
      delAttribute($conn, $oid, $atid);
      break;
    case "rsp_add":
      if($master_slave == "master") {
        $otid_l = $oid;
        $otid_r = $otid;
      } else {
        $otid_l = $otid;
        $otid_r = $oid;
      }
      $rflag = ($rflag == "T") ? "T" : "F";
      addRelationship($conn, $relid, $otid_l, $otid_r, $rflag);
      break;
    case "rsp_del":
      delRelationship($conn, $relid, $otid_l, $otid_r);
      break;
  }
    
  $allOK = true;
  if($item == null):
    //show add/modify form
    $item = new ObjectType($conn);
    if(!$oid) {
      //add action
      $item->oid = $item->newOid();
      $item->name = "";
      $item->category = 1;  //default value
    }
    else {
      //modify operation
      $result = $item->load($oid);
      if($result == false) {
        write_error("Invalid ID!");
        $allOK = false;
      }
      $exists = true;
    }
  endif;
    
  if($allOK && $showForm==true):
?>
    <form action="detail.php" method="post">
      <?if(!$oid || $newRecord): //new record?>
        <input  type="hidden" name="newRecord" value="true">
      <?endif;?>
      <input  type="hidden" name="make_persitent" value="true">
      <table>
        <?form_text_ro("ID:", "oid", $item->oid);?>
        <?form_text_item("Name:", "name", $item->name, 30, 512, true);?>
        <tr>
          <td><B>Category:</B></td>
          <td>
            <?
              $ids = Array();
              $names = Array();
              loadCategories($conn, $ids, $names);
            ?>
            <SELECT  NAME="category" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($ids); $i++) {
                  echo "<OPTION  VALUE=\"".$ids[$i]."\"";
                  echo ($item->category == $ids[$i]) ? "SELECTED" : "";
                  echo ">".$names[$i];
                }?>  
            </SELECT>
          </td>
        </tr>
        <tr><td COLSPAN="2" align="right">
           <input type="Submit" name="action" value="Apply">&nbsp;&nbsp;
          <input type="Reset" value="Reset">&nbsp;&nbsp;
           <input type="Submit" name="action" value="Delete" onClick="return confirm('Really delete?')">
        </td></tr>
      </table>
    </form>
    
    <?if($exists == true):?>
      <H2>Attributes</H2>
<?
      $command = "SELECT AT.ATRT_ID, AT.ATRT_NAME, OTA.OTA_MANDATORY";
      $command .= " FROM OBJ_TYPE_ATTRIBUTES OTA, ATTRIBUTE_TYPES AT";
      $command .= " WHERE OTA.TYPE_ID=".$item->oid;
      $command .= " AND OTA.ATRT_ID = AT.ATRT_ID";
      $command .= " ORDER BY AT.ATRT_CLASS DESC, AT.ATRT_NAME ASC";
      
      $rs = ODBC_Exec($conn, $command);
      def_table_begin();
      echo "<tr><th>Name</th><th>Mandatory</th><th>&nbsp;</th></tr>\n";
      while(ODBC_Fetch_Row($rs)) {
        $atid = ODBC_Result($rs, 1);
        $atname = ODBC_Result($rs, 2);
        $atflag = (ODBC_Result($rs, 3) == "T") ? "YES" : "NO";
        echo "<tr>";
        echo "<td>$atname</td><td align=\"center\">$atflag</td>";
        echo "<td><a href=\"detail.php?ext_code=att_del&oid=$item->oid&atid=$atid\">delete</a></td>";
        echo "</tr>\n";
      }
      def_table_end();
      
      $ids = Array();
      $names = Array();
      loadAtrts($conn, $ids, $names);
?>
      <form action="detail.php" method="post">
        <input type="hidden" name="oid" value="<? echo $item->oid; ?>">
        <input type="hidden" name="ext_code" value="att_add">
        <table><tr>
          <td>
            <SELECT  NAME="atid" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($ids); $i++) {
                  echo "<OPTION  VALUE=\"".$ids[$i]."\"";
                  echo ">".$names[$i];
                }?>  
            </SELECT>
          </td>
          <td>
            <INPUT TYPE="CheckBox" NAME="atflag" VALUE="T"> Mandatory
          </td>
          <td>
            <INPUT TYPE="Submit" NAME="add_attribute" VALUE="Add attribute">
          </td>
        </tr></table>
      </form>
    
      <H2>Relationships</H2>
<?
      $command = "SELECT OTR.REL_ID, RT.REL_NAME, RT.REV_NAME, RT.REL_CARDINALITY, OTR.TYPE_ID_L, OT1.TYPE_NAME, OTR.TYPE_ID_R, OT2.TYPE_NAME, OTR.REL_MANDATORY";
      $command .= " FROM OBJ_TYPE_RELS OTR, REL_TYPES RT, OBJ_TYPES OT1, OBJ_TYPES OT2";
      $command .= " WHERE OTR.REL_ID = RT.REL_ID AND OTR.TYPE_ID_L = OT1.TYPE_ID AND OTR.TYPE_ID_R = OT2.TYPE_ID";
      $command .= " AND (OTR.TYPE_ID_L = ".$item->oid." OR OTR.TYPE_ID_R=".$item->oid.")";
      $command .= " ORDER BY RT.REL_NAME, RT.REV_NAME, OT1.TYPE_NAME, OT2.TYPE_NAME";

      $rs = ODBC_Exec($conn, $command);
      def_table_begin();
      echo "<tr><th>Name</th><th>RevName</th><th>Card.</th><th>Master</th><th>Slave</th><th>Mandatory</th><th>&nbsp;</th></tr>\n";
      while(ODBC_Fetch_Row($rs)) {
        $relid = ODBC_Result($rs, 1);

        $otid_l = ODBC_Result($rs, 5);
        $otname_l = ($item->oid == $otid_l) ? "<B>&lt;this&gt;</B>" : ODBC_Result($rs, 6);
        $otid_r = ODBC_Result($rs, 7);
        $otname_r = ($item->oid == $otid_r) ? "<B>&lt;this&gt;</B>" : ODBC_Result($rs, 8);

        $name = ODBC_Result($rs, 2);
        if($item->oid == $otid_l)
          $name = "<B>".$name."</B>";
        $revName = ODBC_Result($rs, 3);
        if($item->oid == $otid_r)
          $revName = "<B>".$revName."</B>";
        $card = ODBC_Result($rs, 4);
        $rflag = (ODBC_Result($rs, 9) == "T") ? "YES" : "NO";
        echo "<tr>";
        echo "<td>$name</td><td>$revName</td><td align=\"center\">$card</td>";
        echo "<td>$otname_l</td><td>$otname_r</td>";
        echo "<td align=\"center\">$rflag</td>";
        echo "<td><a href=\"detail.php?ext_code=rsp_del&oid=$item->oid&relid=$relid&otid_l=$otid_l&otid_r=$otid_r\">delete</a></td>";
        echo "</tr>\n";
      }
      def_table_end();
      
      $rids = Array();
      $rnames = Array();
      loadRelTypes($conn, $rids, $rnames);
      
      $otids = Array();
      $otnames = Array();
      loadObjTypes($conn, $otids, $otnames);
?>
      <form action="detail.php" method="post">
        <input type="hidden" name="oid" value="<? echo $item->oid; ?>">
        <input type="hidden" name="ext_code" value="rsp_add">
        <table><tr>
          <td>
            <SELECT  NAME="relid" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($rids); $i++) {
                  echo "<OPTION  VALUE=\"".$rids[$i]."\"";
                  echo ">".$rnames[$i];
                }?>  
            </SELECT>
          </td>
          <td>
            <SELECT  NAME="otid" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($otids); $i++) {
                  echo "<OPTION  VALUE=\"".$otids[$i]."\"";
                  echo ">".$otnames[$i];
                }?>  
            </SELECT>
          </td>
          <td>
            <SELECT  NAME="master_slave" ALIGN="left" SIZE="1">
              <OPTION  VALUE="master">Master
              <OPTION  VALUE="slave">Slave
            </SELECT>
          </td>
          <td>
            <INPUT TYPE="CheckBox" NAME="rflag" VALUE="T"> Mandatory
          </td>
          <td>
            <INPUT TYPE="Submit" NAME="add_relationship" VALUE="Add relationship">
          </td>
        </tr></table>

      </form>
<?      
    endif;
    mandatory_notify();
  endif;
?>
    <hr>
    <table>
      <tr>
        <td>
          <form action="browse.php" method="get">
            <input type="Submit" value="Browse">
          </form>
        </td>
        <td>
          <form action="detail.php" method="get">
            <input type="Submit" value="Add">
           </form>
        </td>
      </tr>
    </table>


</BODY>
</HTML>