<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Objects (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2"><TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
<TD>/</TD>
<TD><A href="type_browse.php">Object types</a></TD>
</TR></TABLE>
<HR>
<H1>Objects (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    
    $detail;
    if($mode == "ro") {
      $detail = "ro_detail.php";
      echo "<P align=\"center\">Read-only mode</P>";
    }
    else
      $detail = "detail.php";
    
    $command = "SELECT TYPE_NAME FROM OBJ_TYPES WHERE TYPE_ID=".$otid;
    
    $rs = ODBC_Exec($conn, $command);
    ODBC_Fetch_Row($rs);
    $otname = ODBC_Result($rs, 1);
    
    echo "<P><strong>Object type:</strong>&nbsp;$otname</P>\n";
    
    $command = "SELECT OID AS ID, ONAME AS Name, ODESCR AS Description FROM OBJECTS";
    $command .= " WHERE TYPE_ID = ".$otid;
    
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      echo "<td><a href=\"$detail?otid=$otid&oid=$oid\">$oid</a></td>";
      for($col=2; $col<=$nCols; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<?if($mode != "ro"):?>
<form  action="detail.php" method="get">
<input type="Submit" value="Add">
<input type="hidden" name="otid" value="<?echo $otid;?>">
</form>
<?  
endif;
  } while(false); 
?>
</BODY>
</HTML>