<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>M-cube query tool</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2" width="100%">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
<TD ALIGN="right" WIDTH="99%"><A href="../docs/use.html#qt">Help</A></td>
</TR></TABLE>
<HR>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  
  require "./mcube_ql.php";
  
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
?>
    <FORM ACTION="main.php" METHOD="post">
    <table>
    <tr><td>Write your M-cube query language command here:</td></tr>
    <tr>
    <td>
    <TEXTAREA NAME="mqlCommand" COLS="65" ROWS="10"><? echo StripSlashes($mqlCommand); ?></TEXTAREA>
    </td>
    <td VALIGN="top" align="left">
    <INPUT TYPE="Submit" NAME="action" VALUE="Execute"><BR>
    <INPUT TYPE="Submit" NAME="action" VALUE="Show SQL"><BR>
    <INPUT TYPE="Submit" NAME="action" VALUE="Parse"><BR><BR>
    <INPUT TYPE="CheckBox" NAME="showRebuild" VALUE="true" <? echo $showRebuild ? "CHECKED" : "";?>>ShowRebuild<BR><BR>
    <a href="../docs/ql.txt">QL grammar</a>
    </td>
    </tr>
    </table>
    </FORM>
<?
    if(!Empty($mqlCommand)) {
      $mqlCommand = StripSlashes($mqlCommand);
      if($action == "Execute") {
        $rs = MCUBE_Exec($conn, $mqlCommand);
        if($rs) {
          $nRows = 0;
          $nCols = ODBC_Num_Fields($rs);
           def_table_begin();
           echo "<tr><th>ID</th><th>Name</th></tr>\n";
           while(ODBC_Fetch_Row($rs)) {
            $nRows++;
            $oid = ODBC_Result($rs, 1);
            $otid = ODBC_Result($rs, 2);
            $oname = ODBC_Result($rs, 3);
            echo "<tr><td><a href=\"../objects/detail.php?oid=$oid&otid=$otid\">$oid</a></td>";
            echo "<td>$oname</td></tr>\n";
          }
          def_table_end();
          echo "<P>$nRows rows returned.\n";
        }
      }
      else if($action == "Show SQL") {
        $cmd = MCUBE_Exec($conn, $mqlCommand, "plan");
        echo "<P><B>SQL command translation:</P></B>\n";
        echo "<P><KBD>$cmd<KBD></P>\n";
      }
      else if($action == "Parse") {
        $cmd = MCUBE_Exec($conn, $mqlCommand, "parse");
        echo "<P><B>Parsed statement:</P></B>\n";
        echo "<P><KBD>$cmd<KBD></P>\n";
      }
    }
  } while(false); 
?>
</BODY>
</HTML>