<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Relationship types (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository_manage.php">Admin Center</a></TD>
</TR></TABLE>
<HR>
<H1>Relationship types (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    $rs = ODBC_Exec($conn, "SELECT REL_ID as ID, REL_NAME as Name, REV_NAME as RevName, REL_CARDINALITY as Cardinality, REL_R as Reflexive, REL_S as Symmetric, REL_T as Transitive FROM REL_TYPES");
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      echo "<td><a href=\"detail.php?oid=$oid\">$oid</a></td>";
      for($col=2; $col<=$nCols-3; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      //last three columns (R, S, T)
      for($col=$nCols-2; $col<=$nCols; $col++) {
        $val = ODBC_Result($rs, $col);
        if($val == 'U') {
          $val = "NONE";
        }
        else if($val == 'Y') {
          $val = "YES";
        }
        else if($val == 'N') {
          $val = "ANTI";
        }
        echo "<td>".$val."</td>";
      }
       echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<form  action="detail.php" method="get">
<input  type="Submit" name="Add" value="Add">
</form>
<?  
  } while(false); 
?>
</BODY>
</HTML>