<?
  /* loads all values of given attribute type */
  function  loadAtrtVals($conn, $atrtid, &$ids, &$vals) {
     $command = "SELECT HATR_ID, ATRT_VALUE FROM H_ATRT_VALUES WHERE ATRT_ID=".$atrtid;
    $command .= " ORDER BY ATRT_VALUE";
      
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $vals[] = ODBC_Result($rs, 2);
    }
    return true;
  }
  
  /* load all attribute types */
  function loadAtrts($conn, &$ids, &$names) {
    $command = "SELECT ATRT_ID, ATRT_NAME FROM ATTRIBUTE_TYPES";
    $command .= " ORDER BY ATRT_NAME";
    
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $names[] = ODBC_Result($rs, 2);
    }
    return true;
  }
  
  /* loads all object types */
  function loadObjTypes($conn, &$ids, &$names) {
    $command = "SELECT TYPE_ID, TYPE_NAME FROM OBJ_TYPES ORDER BY TYPE_NAME";
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $names[] = ODBC_Result($rs, 2);
    }
    return true;
  }
  
  function loadRelTypes($conn, &$ids, &$names) {
    $command = "SELECT REL_ID, REL_NAME, REV_NAME, REL_CARDINALITY FROM REL_TYPES ORDER BY REL_NAME";
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $name = ODBC_Result($rs, 2);
      $name .= " / ".ODBC_Result($rs, 3);
      $name .= " (".ODBC_Result($rs, 4).")";
      $names[] = $name;
    }
    return true;
  }

  function loadCategories($conn, &$ids, &$names) {
    $command = "SELECT CATEGORY, DISPLAY_NAME FROM TYPE_CATEGORIES ORDER BY DISPLAY_NAME";
    
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $names[] = ODBC_Result($rs, 2);
    }
    return true;
  }
  
  function loadRelatedObjs($conn, $relid, $master, $oid, $otid_second, &$ids, &$names) {
    if($master) {
      $command = "SELECT RSP.OID_R, OBJ.ONAME FROM RELATIONSHIPS RSP, OBJECTS OBJ";
      $command .= " WHERE RSP.OID_R = OBJ.OID AND OBJ.TYPE_ID=".$otid_second;
      $command .= " AND RSP.REL_ID=".$relid;
      $command .= " AND RSP.OID_L=".$oid;
      $command .= " ORDER BY OBJ.ONAME";      
    }
    else { //slave
      $command = "SELECT RSP.OID_L, OBJ.ONAME FROM RELATIONSHIPS RSP, OBJECTS OBJ";
      $command .= " WHERE RSP.OID_L = OBJ.OID AND OBJ.TYPE_ID=".$otid_second;
      $command .= " AND RSP.REL_ID=".$relid;
      $command .= " AND RSP.OID_R=".$oid;
      $command .= " ORDER BY OBJ.ONAME";      
    }
    
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $names[] = ODBC_Result($rs, 2);
    }
  }
  
  function loadObjects($conn, $otid, &$ids, &$names) {
    $command = "SELECT OID, ONAME FROM OBJECTS WHERE TYPE_ID=".$otid;
    $command .= " ORDER BY ONAME";
    
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ids[] = ODBC_Result($rs, 1);
      $names[] = ODBC_Result($rs, 2);
    }
  }
?>